;/---------------------------\
;| Thorium Ressource Manager |
;|                           |
;| Example                   |
;|                           |
;| Version 0.02              |
;| Date: 18.08.2009          |
;|                           |
;| PureBasic 4.40            |
;\---------------------------/

EnableExplicit

CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
  Import "ThoriumRessourceManager64.lib"
    ResInitManager.i(RessourcePath.s, Language.i, CallbackAddr.i)
    ResLoad.i(ResName.s)
    ResChangeLang.i(Language.i)
    ResGetLastError.i()
  EndImport
CompilerElse
  Import "ThoriumRessourceManager32.lib"
    ResInitManager.i(RessourcePath.s, Language.i, CallbackAddr.i)
    ResLoad.i(ResName.s)
    ResChangeLang.i(Language.i)
    ResGetLastError.i()
  EndImport
CompilerEndIf

#ResError_NoAccessFile             = 1  ;no access to file
#ResError_WrongOrDmgArchiv         = 2  ;archive is'nt a ThorReCo or damaged
#ResError_UnsupArchivFormat        = 3  ;not supported archive format
#ResError_UnsupArchivFotmatVersion = 4  ;not supported version of archive format
#ResError_UnsupCompInArchiv        = 5  ;not supported compression used in archive
#ResError_ArchivIsBig              = 6  ;archive is bigger than 2GB and thats not supported
#ResError_ArchivIsHuge             = 7  ;archive is bigger than 4GB and thats not supported
#ResError_UnsupDirComp             = 8  ;directory of archive is compressed witch unsupported compression
#ResError_AllocMem                 = 9  ;not enough memory
#ResError_ReadFile                 = 10 ;error on reading file
#ResError_Decomp                   = 11 ;error on decompression
#ResError_NoAccessDir              = 12 ;no access to directory
#ResError_OutOfIndex               = 13 ;out of index
#ResError_ResNotFound              = 14 ;ressource is not indexed

#ResLang_German  = 1
#ResLang_English = 2

Global ImageRes.i
Global TextRes.i

Procedure Callback(ResIndex.i, Addr.i, Size.i, Error.i)

  Select ResIndex
  
    Case ImageRes
      If Error = 0
        CatchImage(0, Addr, Size)
        SetGadgetState(1, ImageID(0))        
      Else
        MessageRequester("Example", "picture.bmp", 16)
      EndIf
    
    Case TextRes
      If Error = 0
        SetGadgetText(0, PeekS(Addr, Size))
      Else
        MessageRequester("Example", "Error on loading text.txt!", 16)
      EndIf
  
  EndSelect

EndProcedure

Define Exit.i
Define Event.i

OpenWindow(0, 216, 0, 596, 364, "Example",  #PB_Window_SystemMenu | #PB_Window_SizeGadget | #PB_Window_TitleBar )
EditorGadget(0, 10, 10, 570, 170)
ImageGadget(1, 10, 190, 570, 160, 0)

;to test the multilanguage support just replace #ResLang_English with #ResLang_German
If ResInitManager("ResDir\", #ResLang_English, @Callback()) = 0
  MessageRequester("Example", "Init failed!", 16)
  End
EndIf

ImageRes = ResLoad("picture.bmp")
If ImageRes = 0
  MessageRequester("Example", "picture.bmp not found")
EndIf

TextRes = ResLoad("text.txt")
If TextRes = 0
  MessageRequester("Example", "text.txt not found")
EndIf

Repeat

  Event = WaitWindowEvent()

  If Event = #PB_Event_CloseWindow
    Exit = 1
  EndIf

Until Exit = 1

; IDE Options = PureBasic 4.40 Beta 2 (Windows - x86)
; Folding = +
; EnableThread
; EnableXP
; Executable = D:\Thorium Ressource Manager\Example.exe